c
c
c************************  Test fo PROGS2H4 **********************************
c************************  Ex.814 from [1]  **********************************
c
c	           d2x-3x-4y =0
c	           d2y+ y+ x =0
c
c     analytical solution:
c     x=-2*exp(t)*(c1+c2+c2*t)-2*exp(-t)*(c3-c4+c4*t)
c     y=   exp(t)*(c1+   c2*t)+  exp(-t)*(c3+   c4*t)
c
c     f(1,1,i)=-3; 
c     f(1,2,i)=-4; 
c     f(2,1,i)=1;
c     f(2,2,i)=1; 
c     p(1,1,i)=p(1,2,i)=p(2,1,i)=p(2,2,i)=0;
c
c
c      [1].        A.F.Filippov. Sbornik zadach po differencialnym uravneniyam.
c                  Moskwa, Nauka, 1973.
c
c *****************************************************************************

      implicit real *8(a-h,o-z)
	parameter (n=501)

      dimension f(2,2,n),p(2,2,n),uk(2,n),d1(2),d2(2),f1(2),f2(2),g1(2)
      dimension x(n),u1a(n),u2a(n),g2(2),am(2,2,n),bm(2,n),v(2,n)
                  
      open(11,file='fort11')
c
c---------------------- interval [a,b]
c
       a  = 0.
       b  = 5.

	 n1 = n-1
	 l  = 2 
       h=(b-a)/(n-1)

            
       print *,' n=',n
c
c------------------- analytic solution
c       
       c1=1
       c2=1
       c3=1
       c4=1

	do i=1,n
	x(i) = h*(i-1)+a
	t = x(i)
	u1a(i)=-2.d0*dexp(t) *(c1+c2+c2*t)-2.d0*dexp(-t)*(c3-c4+c4*t)
      u2a(i)=dexp(t)*(c1+c2*t)+dexp(-t)*(c3+c4*t)
	end do

		       
	 print *, ' c1, c2, c3 , c4 :',c1,c2,c3,c4
        
      write (11,*)'      TEST FOR PROGS2H4' 
	write (11,*) ' '
	write (11,*) ' c1=',c1,' c2=',c2,' c3=',c3,' c4=',c4
      write (11,*) ' n=',n

       
c------------------- coefficients to boundary conditions      
      

	do i=1,2
	d1(i) = 0.
	d2(i) = 0.
	f1(i) = 1.
	f2(i) = 1.
	end do

	g1(1) = u1a(1)
	g1(2) = u2a(1)
	g2(1) = u1a(n)
	g2(2) = u2a(n)

      do i  = 2,n1
       f(1,1,i)=-3.d0
       f(1,2,i)=-4.d0
       f(2,1,i)=+1.d0
       f(2,2,i)=+1.d0
       p(1,1,i)= 0.d0
       p(1,2,i)= 0.d0
       p(2,1,i)= 0.d0
       p(2,2,i)= 0.d0
       uk(1,i)=  0.d0
       uk(2,i)=  0.d0
      end do
       
 

      call progs2h4p(n,h,f,p,uk,d1,d2,f1,f2,g1,g2,v,am,bm)


c---------------------- calculation of residual

 	delmax = 0.
	do i=1,n
	do j=1,2
	del1	= abs(v(1,i)-u1a(i))
	if(del1.gt.delmax) delmax = del1
	del2	= abs(v(2,i)-u2a(i))
	if(del2.gt.delmax) delmax = del2
	end do
	end do
	
	write(*,*) 'calculation has been finished'
	write(*,*) 'max residual is',delmax

	do i=1,n
	write(11,*) x(i),v(1,i),v(2,i)
	end do

      end
c*
c***********************************************************************
c*


      subroutine progs2h4p(n,h,f,p,uk,d1,d2,f1,f2,g1,g2,y,am,bm)
c
c------------------------------------------------------------------
c     Zemlyanaya E.V., E.V.Puzynina
c     Solution of the boundary problem for the system of two diff. eqs.
c     the 4th order accuracy is provided by Numerov's scheme
c------------------------------------------------------------------
c
c
c      REFERENCE:
c	 E.V.Zemlyanaya, I.V.Puzynin, T.P.Puzynina
c      JINR PREPRINT P11-97-414, Dubna, 1997
c
c
c
c  the system:
c
c		d2y1+p_{11}*dy1+f_{11}*y1+p_{12}*dy1+f_{12}*y1 = uk_1
c	    d2y2+p_{21}*dy2+f_{21}*y2+p_{22}*dy2+f_{22}*y2 = uk_2
c		
c left boudary conditions
c
c		d1(1)*dy1_1+f1(1)*y1_1=g1(1)
c		d2(1)*dy1_n+f2(1)*y1_n=g2(1)
c
c right boundary conditions
c
c	    d1(2)*dy2_1+f1(2)*y2_1=g1(2)
c		d2(2)*dy2_n+f2(2)*y2_n=g2(2)
c
c
c parameters of the subroutine
c
c	n = number of points of the discrete network on argument
c	h = stepsize of the discrete detwork on argument 
c	p(2,2,n),f(2,2,n),uk(2,n) -  arrays of coefficients of the system.
c     f1(2),f2(2),g1(2),g2(2),d1(2),d2(2) - coefficients of the boundary conditions
c	y(2,n) - solution of the system
c     am(2,2,n),bm(2,2,n) - working arrays
c
c
      implicit real*8 (a-h,o-z)
      dimension f(2,2,n),p(2,2,n),uk(2,n),d1(2),d2(2),f1(2),f2(2),g1(2),
     ^          g2(2),y(2,n),am(2,2,n),bm(2,n),e(10,11),index(11)
c
	l=2	
      n1   = n-1
      n2   = n-2
      n3   = n-3
      n4   = n-4
      n5   = n-5
      hh   = h*h
      h7d6 = hh*7./6.
      h5d12= hh*5./12.
      hd3  = hh/3.
      hd12 = hh/12.
      h5d6 = hh*5./6.

      h3p12= h*hh/12.
      h12  = 12.*h
	h524 = 5.*h/24.
	h712 = 7.*h/12.
    	h6=h/6.
	h8=h/8.
    	h24  = h/24.

      do i  = 1,n
      do j  = 1,l
      bm(j,i)  = 0.
      do k  = 1,l
      am(k,j,i)= 0.
      end do
      end do
      end do

c--------------------------------------- the left system
c
c--------------------------------- i=1
c
      a1   = -25.*d1(1)+h12*f1(1)
      b1   = 48.*d1(1)
      c1   = -36.*d1(1)
      dd1  = 16.*d1(1)
      e1   = -3.*d1(1)
      uk1h = h12*g1(1)
c
      a1v  = -25.*d1(2)+h12*f1(2)
      b1v  = 48.*d1(2)
      c1v  = -36.*d1(2)
      dd1v = 16.*d1(2)
      e1v  = -3.*d1(2)
      uk1hv= h12*g1(2)
c
c--------------------------------- i=2
c
      a2   = 1.
      b2   = -2.+h7d6*f(1,1,2)
      c2   = 1.-h5d12*f(1,1,3)
      dd2  = hd3*f(1,1,4)
      e2   = -hd12*f(1,1,5)
      b2c  = h7d6*f(1,2,2)
      c2c  = -h5d12*f(1,2,3)
      dd2c = hd3*f(1,2,4)
      e2c  = -hd12*f(1,2,5)
      uk2h = uk(1,2)*h7d6-h5d12*uk(1,3)+hd3*uk(1,4)-hd12*uk(1,5)

c
      a2v  = 1.
      b2v  = -2.+h7d6*f(2,1,2)
      c2v  = 1.-h5d12*f(2,1,3)
      dd2v = hd3*f(2,1,4)
      e2v  = -hd12*f(2,1,5)
      b2cv = h7d6*f(2,2,2)
      c2cv = -h5d12*f(2,2,3)
      dd2cv= hd3*f(2,2,4)
      e2cv = -hd12*f(2,2,5)
      uk2hv= uk(2,2)*h7d6-h5d12*uk(2,3)+hd3*uk(2,4)-hd12*uk(2,5)

corr for general case

	a2c  = 0.
	a2cv = 0.

c
c for system with first derivatives.  (begin corrections 1, formulas 24,18)
c
	r    = -1.5*p(1,1,2)/h
	s    = 3.*f(1,1,2)+2.*p(1,1,3)/h
	u    = 1.5*p(1,1,2)/h-4.*f(1,1,3)-0.5*p(1,1,4)/h
	v    = -2.*p(1,1,3)/h+f(1,1,4)
	w    = 0.5*p(1,1,4)/h

	rc   = -1.5*p(1,2,2)/h
	sc   = 3.*f(1,2,2)+2.*p(1,2,3)/h
	uc   = 1.5*p(1,2,2)/h-4.*f(1,2,3)-0.5*p(1,2,4)/h
	vc   = -2.*p(1,2,3)/h+f(1,2,4)
	wc   = 0.5*p(1,2,4)/h
	t    = -3.*uk(1,2)+4.*uk(1,3)-uk(1,4)

	rv   = -1.5*p(2,1,2)/h
	sv   = 3.*f(2,1,2)+2.*p(2,1,3)/h
	uv   = 1.5*p(2,1,2)/h-4.*f(2,1,3)-0.5*p(2,1,4)/h
	vv   = -2.*p(2,1,3)/h+f(2,1,4)
	wv   = 0.5*p(2,1,4)/h

	rcv  = -1.5*p(2,2,2)/h
	scv  = 3.*f(2,2,2)+2.*p(2,2,3)/h
	ucv  = 1.5*p(2,2,2)/h-4.*f(2,2,3)-0.5*p(2,2,4)/h
	vcv  = -2.*p(2,2,3)/h+f(2,2,4)
	wcv  = 0.5*p(2,2,4)/h
	tv   = -3.*uk(2,2)+4.*uk(2,3)-uk(2,4)


	a2   = a2-h712*p(1,1,2)-h3p12*(p(1,1,2)*r+p(1,2,2)*rcv)
	b2   = b2+h524*p(1,1,3)-h3p12*(p(1,1,2)*s+p(1,2,2)*scv)
	c2   = c2-h24*(-13.*p(1,1,2)+p(1,1,4)+p(1,1,5))-
     -         h3p12*(p(1,1,2)*u+p(1,2,2)*ucv)
	dd2  = dd2-h524*p(1,1,3)-h3p12*(p(1,1,2)*v+p(1,2,2)*vcv)
	e2   = e2-h24*(-4.*p(1,1,4)+3.*p(1,1,5))-
     -         h3p12*(p(1,1,2)*w+p(1,2,2)*wcv)
	a2c  = a2c-h712*p(1,2,2)-h3p12*(p(1,1,2)*rc+p(1,2,2)*rv)
	b2c  = b2c+h524*p(1,2,3)-h3p12*(p(1,1,2)*sc+p(1,2,2)*sv)
	c2c  = c2c-h24*(-13.*p(1,2,2)+p(1,2,4)+p(1,2,5))-
     -         h3p12*(p(1,1,2)*uc+p(1,2,2)*uv)
	dd2c = dd2c-h524*p(1,2,3)-h3p12*(p(1,1,2)*vc+p(1,2,2)*vv)
	e2c  = e2c-h24*(-4.*p(1,2,4)+3.*p(1,2,5))-
     -         h3p12*(p(1,1,2)*wc+p(1,2,2)*wv)

      uk2h = uk2h-h3p12*(p(1,1,2)*t+p(1,2,2)*tv)

c

	a2v  = a2v-h712*p(2,1,2)-h3p12*(p(2,1,2)*rv+p(2,2,2)*rc)
	b2v  = b2v+h524*p(2,1,3)-h3p12*(p(2,1,2)*sv+p(2,2,2)*sc)
	c2v  = c2v-h24*(-13.*p(2,1,2)+p(2,1,4)+p(2,1,5))-
     -         h3p12*(p(2,1,2)*uv+p(2,2,2)*uc)
	dd2v = dd2v-h524*p(2,1,3)-h3p12*(p(2,1,2)*vv+p(2,2,2)*vc)
	e2v  = e2v-h24*(-4.*p(2,1,4)+3.*p(2,1,5))-
     -         h3p12*(p(2,1,2)*wv+p(2,2,2)*wc)
	a2cv = a2cv-h712*p(2,2,2)-h3p12*(p(2,1,2)*rcv+p(2,2,2)*r)
	b2cv = b2cv+h524*p(2,2,3)-h3p12*(p(2,1,2)*scv+p(2,2,2)*s)
	c2cv = c2cv-h24*(-13.*p(2,2,2)+p(2,2,4)+p(2,2,5))-
     -         h3p12*(p(2,1,2)*ucv+p(2,2,2)*u)
	dd2cv= dd2cv-h524*p(2,2,3)-h3p12*(p(2,1,2)*vcv+p(2,2,2)*v)
	e2cv = e2cv-h24*(-4.*p(2,2,4)+3.*p(2,2,5))-
     -         h3p12*(p(2,1,2)*wcv+p(2,2,2)*w)

      uk2hv= uk2hv-h3p12*(p(2,1,2)*tv+p(2,2,2)*t)

c
c for system with first derivatives.  (end corrections 1)
c


c--------------------------------- i=3

c
corr for general case
	i=  3
      im1=i-1
      ip1=i+1

c formulas (22)

      a3   = 1.+hd12*f(1,1,im1)
      b3   = h5d6*f(1,1,i)-2.
      c3   = 1.+hd12*f(1,1,ip1)
      a3c  = hd12*f(1,2,im1)
      b3c  = h5d6*f(1,2,i)
      c3c  = hd12*f(1,2,ip1)
      f3   = uk(1,i)*hh+hd12*(uk(1,ip1)-2.*uk(1,i)+uk(1,im1))
c
      a3v  = 1.+hd12*f(2,1,im1)
      b3v  = h5d6*f(2,1,i)-2.
      c3v  = 1.+hd12*f(2,1,ip1)
      a3cv = hd12*f(2,2,im1)
      b3cv = h5d6*f(2,2,i)
      c3cv = hd12*f(2,2,ip1)
      f3v  = uk(2,i)*hh+hd12*(uk(2,ip1)-2.*uk(2,i)+uk(2,im1))

c
c for system with first derivatives.  (begin corrections 2, formulas 22,16)
c
c
      aicl  = f(1,1,im1)-0.5*(p(1,1,ip1)+3.*p(1,1,im1))/h
      bicl  = 2.*(p(1,1,ip1)+p(1,1,im1))/h
      cicl  = -f(1,1,ip1)-0.5*(3.*p(1,1,ip1)+p(1,1,im1))/h
      aiclc = f(1,2,im1)-0.5*(p(1,2,ip1)+3.*p(1,2,im1))/h
      biclc = 2.*(p(1,2,ip1)+p(1,2,im1))/h
      ciclc = -f(1,2,ip1)-0.5*(3.*p(1,2,ip1)+p(1,2,im1))/h
      ficl  = uk(1,ip1)-uk(1,im1)
c
      aiclv = f(2,1,im1)-0.5*(p(2,1,ip1)+3.*p(2,1,im1))/h
      biclv = 2.*(p(2,1,ip1)+p(2,1,im1))/h
      ciclv = -f(2,1,ip1)-0.5*(3.*p(2,1,ip1)+p(2,1,im1))/h
      aiclcv= f(2,2,im1)-0.5*(p(2,2,ip1)+3.*p(2,2,im1))/h
      biclcv= 2.*(p(2,2,ip1)+p(2,2,im1))/h
      ciclcv= -f(2,2,ip1)-0.5*(3.*p(2,2,ip1)+p(2,2,im1))/h
      ficlv=  uk(2,ip1)-uk(2,im1)

      a3   = a3-h24*(-p(1,1,ip1)+10.*p(1,1,i)+3.*p(1,1,im1))-
     -       h3p12*(p(1,1,i)*aicl+p(1,2,i)*aiclcv)
      b3   = b3-h6*(p(1,1,ip1)-p(1,1,im1))-
     -       h3p12*(p(1,1,i)*bicl+p(1,2,i)*biclcv)
      c3   = c3-h24*(-3.*p(1,1,ip1)-10.*p(1,1,i)+p(1,1,im1))-
     -       h3p12*(p(1,1,i)*cicl+p(1,2,i)*ciclcv)
      a3c  = a3c-h24*(-p(1,2,ip1)+10.*p(1,2,i)+3.*p(1,2,im1))-
     -       h3p12*(p(1,1,i)*aiclc+p(1,2,i)*aiclv)
      b3c  = b3c-h6*(p(1,2,ip1)-p(1,2,im1))-
     -       h3p12*(p(1,1,i)*biclc+p(1,2,i)*biclv)
      c3c  = c3c-h24*(-3.*p(1,2,ip1)-10.*p(1,2,i)+p(1,2,im1))-
     -       h3p12*(p(1,1,i)*ciclc+p(1,2,i)*ciclv)

      f3   = f3-h3p12*(p(1,1,i)*ficl+p(1,2,i)*ficlv)

c
      a3v  = a3v-h24*(-p(2,1,ip1)+10.*p(2,1,i)+3.*p(2,1,im1))-
     -       h3p12*(p(2,1,i)*aiclv+p(2,2,i)*aiclc)
      b3v  = b3v-h6*(p(2,1,ip1)-p(2,1,im1))-
     -       h3p12*(p(2,1,i)*biclv+p(2,2,i)*biclc)
      c3v  = c3v-h24*(-3.*p(2,1,ip1)-10.*p(2,1,i)+p(2,1,im1))-
c     -       h3p12*(p(2,1,i)*ciclc+p(2,2,i)*ciclc)
     -       h3p12*(p(2,1,i)*ciclv+p(2,2,i)*ciclc)
      a3cv = a3cv-h24*(-p(2,2,ip1)+10.*p(2,2,i)+3.*p(2,2,im1))-
     -       h3p12*(p(2,1,i)*aiclcv+p(2,2,i)*aicl)
      b3cv = b3cv-h6*(p(2,2,ip1)-p(2,2,im1))-
     -       h3p12*(p(2,1,i)*biclcv+p(2,2,i)*bicl)

corr 17.07.97
c      c3cv = c3cv-h24*(-3.*p(2,1,ip1)-10.*p(2,1,i)+p(2,1,im1))-
      c3cv = c3cv-h24*(-3.*p(2,2,ip1)-10.*p(2,2,i)+p(2,2,im1))-

     -       h3p12*(p(2,1,i)*ciclcv+p(2,2,i)*cicl)


      f3v  = f3v-h3p12*(p(2,1,i)*ficlv+p(2,2,i)*ficl)

c

c for system with first derivatives.  (end corrections 2)
c

c
c--------------------------------- i=4
c

corr for general case

	i  =4
      im1=i-1
      ip1=i+1

      a4   = 1.+hd12*f(1,1,im1)
      b4   = h5d6*f(1,1,i)-2.
      c4   = 1.+hd12*f(1,1,ip1)
      a4c  = hd12*f(1,2,im1)
      b4c  = h5d6*f(1,2,i)
      c4c  = hd12*f(1,2,ip1)
      f4   = uk(1,i)*hh+hd12*(uk(1,ip1)-2.*uk(1,i)+uk(1,im1))
c
      a4v  = 1.+hd12*f(2,1,im1)
      b4v  = h5d6*f(2,1,i)-2.
      c4v  = 1.+hd12*f(2,1,ip1)
      a4cv = hd12*f(2,2,im1)
      b4cv = h5d6*f(2,2,i)
      c4cv = hd12*f(2,2,ip1)
      f4v  = uk(2,i)*hh+hd12*(uk(2,ip1)-2.*uk(2,i)+uk(2,im1))

c
c for system with first derivatives.  (begin corrections 3, formulas 22,16)
c
      aicl  = f(1,1,im1)-0.5*(p(1,1,ip1)+3.*p(1,1,im1))/h
      bicl  = 2.*(p(1,1,ip1)+p(1,1,im1))/h
      cicl  = -f(1,1,ip1)-0.5*(3.*p(1,1,ip1)+p(1,1,im1))/h
      aiclc = f(1,2,im1)-0.5*(p(1,2,ip1)+3.*p(1,2,im1))/h
      biclc = 2.*(p(1,2,ip1)+p(1,2,im1))/h
      ciclc = -f(1,2,ip1)-0.5*(3.*p(1,2,ip1)+p(1,2,im1))/h
      ficl  = uk(1,ip1)-uk(1,im1)
c
      aiclv = f(2,1,im1)-0.5*(p(2,1,ip1)+3.*p(2,1,im1))/h
      biclv = 2.*(p(2,1,ip1)+p(2,1,im1))/h
      ciclv = -f(2,1,ip1)-0.5*(3.*p(2,1,ip1)+p(2,1,im1))/h
      aiclcv= f(2,2,im1)-0.5*(p(2,2,ip1)+3.*p(2,2,im1))/h
      biclcv= 2.*(p(2,2,ip1)+p(2,2,im1))/h
      ciclcv= -f(2,2,ip1)-0.5*(3.*p(2,2,ip1)+p(2,2,im1))/h
      ficlv=  uk(2,ip1)-uk(2,im1)


      a4   = a4-h24*(-p(1,1,ip1)+10.*p(1,1,i)+3.*p(1,1,im1))-
     -       h3p12*(p(1,1,i)*aicl+p(1,2,i)*aiclcv)
      b4   = b4-h6*(p(1,1,ip1)-p(1,1,im1))-
     -       h3p12*(p(1,1,i)*bicl+p(1,2,i)*biclcv)
      c4   = c4-h24*(-3.*p(1,1,ip1)-10.*p(1,1,i)+p(1,1,im1))-
     -       h3p12*(p(1,1,i)*cicl+p(1,2,i)*ciclcv)
      a4c  = a4c-h24*(-p(1,2,ip1)+10.*p(1,2,i)+3.*p(1,2,im1))-
     -       h3p12*(p(1,1,i)*aiclc+p(1,2,i)*aiclv)
      b4c  = b4c-h6*(p(1,2,ip1)-p(1,2,im1))-
     -       h3p12*(p(1,1,i)*biclc+p(1,2,i)*biclv)
      c4c  = c4c-h24*(-3.*p(1,2,ip1)-10.*p(1,2,i)+p(1,2,im1))-
     -       h3p12*(p(1,1,i)*ciclc+p(1,2,i)*ciclv)


      f4   = f4-h3p12*(p(1,1,i)*ficl+p(1,2,i)*ficlv)

c
      a4v  = a4v-h24*(-p(2,1,ip1)+10.*p(2,1,i)+3.*p(2,1,im1))-
     -       h3p12*(p(2,1,i)*aiclv+p(2,2,i)*aiclc)
      b4v  = b4v-h6*(p(2,1,ip1)-p(2,1,im1))-
     -       h3p12*(p(2,1,i)*biclv+p(2,2,i)*biclc)
      c4v  = c4v-h24*(-3.*p(2,1,ip1)-10.*p(2,1,i)+p(2,1,im1))-
c     -       h3p12*(p(2,1,i)*ciclc+p(2,2,i)*ciclc)
     -       h3p12*(p(2,1,i)*ciclv+p(2,2,i)*ciclc)
      a4cv = a4cv-h24*(-p(2,2,ip1)+10.*p(2,2,i)+3.*p(2,2,im1))-
     -       h3p12*(p(2,1,i)*aiclcv+p(2,2,i)*aicl)
      b4cv = b4cv-h6*(p(2,2,ip1)-p(2,2,im1))-
     -       h3p12*(p(2,1,i)*biclcv+p(2,2,i)*bicl)

corr 17.07.97
c      c4cv = c4cv-h24*(-3.*p(2,1,ip1)-10.*p(2,1,i)+p(2,1,im1))-
      c4cv = c4cv-h24*(-3.*p(2,2,ip1)-10.*p(2,2,i)+p(2,2,im1))-

     -       h3p12*(p(2,1,i)*ciclcv+p(2,2,i)*cicl)

      f4v  = f4v-h3p12*(p(2,1,i)*ficlv+p(2,2,i)*ficl)

c
c for system with first derivatives.  (end corrections 3)
c

c formulas (42)
      s    = a2/a1
      sv   = a2v/a1v
c
      s2   = b2-s*b1
      s3   = c2-s*c1
      s4   = dd2-s*dd1
      s5   = e2-s*e1
      q2   = uk2h-s*uk1h
c
      s2v  = b2v-sv*b1v
      s3v  = c2v-sv*c1v
      s4v  = dd2v-sv*dd1v
      s5v  = e2v-sv*e1v
      q2v  = uk2hv-sv*uk1hv
c

c formulas (43),(44)
      as   = a3/s2
      asv  = a3v/s2v
      znam = a3c-as*b2c
      znamv= a3cv-asv*b2cv
c
      q3   = (f3 -as*q2)  /znam
      z3   = (b3 -as*s3)  /znam
      z4   = (c3 -as*s4)  /znam
      z5   =     -as*s5   /znam
      z3c  = (b3c-as*c2c) /znam
      z4c  = (c3c-as*dd2c)/znam
      z5c  =     -as*e2c  /znam
c
      q3v  = (f3v -asv*q2v) /znamv
      z3v  = (b3v -asv*s3v) /znamv
      z4v  = (c3v -asv*s4v) /znamv
      z5v  =      -asv*s5v  /znamv
      z3cv = (b3cv-asv*c2cv)/znamv
      z4cv = (c3cv-asv*dd2cv)/znamv
      z5cv =      -asv*e2cv /znamv
c
c formulas (46)
      w3   = -a3 *z3cv+b3 -a3c*z3
      w4   = -a3 *z4cv+c3 -a3c*z4
      w5   = -a3 *z5cv    -a3c*z5
      w3c  = -a3 *z3v +b3c-a3c*z3c
      w4c  = -a3 *z4v +c3c-a3c*z4c
      w5c  = -a3 *z5v     -a3c*z5c
      q4   =  f3-a3*q3v-a3c*q3
c
      w3v  = -a3v*z3c +b3v -a3cv*z3v
      w4v  = -a3v*z4c +c3v -a3cv*z4v
      w5v  = -a3v*z5c      -a3cv*z5v
      w3cv = -a3v*z3  +b3cv-a3cv*z3cv
      w4cv = -a3v*z4  +c3cv-a3cv*z4cv
      w5cv = -a3v*z5       -a3cv*z5cv
      q4v  =  f3v-a3v*q3-a3cv*q3v
c
c formulas (48)
      v3c  = w3v *w3-w3c*w3cv
      v4   = w4cv*w3-w4 *w3cv
      v4c  = w4v *w3-w4c*w3cv
      v5   = w5cv*w3-w5 *w3cv
      v5c  = w5v *w3-w5c*w3cv
      q5   = q4v *w3-q4 *w3cv
c
      v3cv = w3cv*w3c-w3 *w3v
      v4v  = w4v *w3c-w4c*w3v
      v4cv = w4cv*w3c-w4 *w3v
      v5v  = w5v *w3c-w5c*w3v
      v5cv = w5cv*w3c-w5 *w3v
      q5v  = q4v *w3c-q4 *w3v
c
c formulas (50)
      am1v = a4/v3cv
      am2v = a4c/v3c
c
      r4   = -am1v*v4cv+b4 -am2v*v4
      r4c  = -am1v*v4v +b4c-am2v*v4c
      r5   = -am1v*v5cv+c4 -am2v*v5
      r5c  = -am1v*v5v +c4c-am2v*v5c
      q6   =  f4-am1v*q5v-am2v*q5
c
      am1v =  a4v/v3c
      am2v =  a4cv/v3cv
c

      r4v  = -am1v*v4c+b4v -am2v*v4v
      r4cv = -am1v*v4 +b4cv-am2v*v4cv
      r5v  = -am1v*v5c+c4v -am2v*v5v
      r5cv = -am1v*v5 +c4cv-am2v*v5cv
      q6v  =  f4v-am1v*q5-am2v*q5v
c
c formulas (53)

      x4c  = r4c*r4cv-r4v *r4
      x4cv = r4 *r4v -r4cv*r4c
      x5   = r5 *r4cv-r5cv*r4
      x5c  = r5c*r4cv-r5v *r4
      x5v  = r5c*r4v -r5v *r4c
      x5cv = r5 *r4v -r5cv*r4c
      q7   = q6 *r4cv-q6v*r4
      q7v  = q6 *r4v -q6v *r4c
c
c formulas (52)
      am(1,1,i) = -x5cv/x4cv
      am(1,2,i) = -x5v/x4cv
      bm(1,i)   =  q7v/x4cv
      am(2,1,i) = -x5c/x4c
      am(2,2,i) = -x5/x4c
      bm(2,i)   =  q7/x4c


c----------------------------------- from i=5 to i=n-2

c
      do 10 i=5,n2
      im1=i-1
      ip1=i+1
c
      ai   = 1.+hd12*f(1,1,im1)
      bi   = h5d6*f(1,1,i)-2.
      ci   = 1.+hd12*f(1,1,ip1)
      aic  = hd12*f(1,2,im1)
      bic  = h5d6*f(1,2,i)
      cic  = hd12*f(1,2,ip1)
      fi   = uk(1,i)*hh+hd12*(uk(1,ip1)-2.*uk(1,i)+uk(1,im1))
c
      aiv  = 1.+hd12*f(2,1,im1)
      biv  = h5d6*f(2,1,i)-2.
      civ  = 1.+hd12*f(2,1,ip1)
      aicv = hd12*f(2,2,im1)
      bicv = h5d6*f(2,2,i)
      cicv = hd12*f(2,2,ip1)
      fiv  = uk(2,i)*hh+hd12*(uk(2,ip1)-2.*uk(2,i)+uk(2,im1))
c
c for system with first derivatives.  (begin corrections 4, formulas 22,16)
c
      aicl  =  f(1,1,im1)-0.5*(p(1,1,ip1)+3.*p(1,1,im1))/h
      bicl  =  2.*(p(1,1,ip1)+p(1,1,im1))/h
      cicl  = -f(1,1,ip1)-0.5*(3.*p(1,1,ip1)+p(1,1,im1))/h

corr 17.07.97
c      aiclc =  f(1,2,im1)-0.5*(p(1,2,ip1)+3.*p(1,1,im1))/h

      aiclc =  f(1,2,im1)-0.5*(p(1,2,ip1)+3.*p(1,2,im1))/h
      biclc =  2.*(p(1,2,ip1)+p(1,2,im1))/h
      ciclc = -f(1,2,ip1)-0.5*(3.*p(1,2,ip1)+p(1,2,im1))/h
      ficl  =  uk(1,ip1)-uk(1,im1)
c
      aiclv =  f(2,1,im1)-0.5*(p(2,1,ip1)+3.*p(2,1,im1))/h
      biclv =  2.*(p(2,1,ip1)+p(2,1,im1))/h
      ciclv = -f(2,1,ip1)-0.5*(3.*p(2,1,ip1)+p(2,1,im1))/h

corr 17.07.97
c      aiclcv=  f(2,2,im1)-0.5*(p(2,2,ip1)+3.*p(2,1,im1))/h

      aiclcv=  f(2,2,im1)-0.5*(p(2,2,ip1)+3.*p(2,2,im1))/h
      biclcv=  2.*(p(2,2,ip1)+p(2,2,im1))/h
      ciclcv= -f(2,2,ip1)-0.5*(3.*p(2,2,ip1)+p(2,2,im1))/h
      ficlv=   uk(2,ip1)-uk(2,im1)
 

      ai   = ai-h24*(-p(1,1,ip1)+10.*p(1,1,i)+3.*p(1,1,im1))-
     -       h3p12*(p(1,1,i)*aicl+p(1,2,i)*aiclcv)
      bi   = bi-h6*(p(1,1,ip1)-p(1,1,im1))-
     -       h3p12*(p(1,1,i)*bicl+p(1,2,i)*biclcv)
      ci   = ci-h24*(-3.*p(1,1,ip1)-10.*p(1,1,i)+p(1,1,im1))-
     -       h3p12*(p(1,1,i)*cicl+p(1,2,i)*ciclcv)
      aic  = aic-h24*(-p(1,2,ip1)+10.*p(1,2,i)+3.*p(1,2,im1))-
     -       h3p12*(p(1,1,i)*aiclc+p(1,2,i)*aiclv)
      bic  = bic-h6*(p(1,2,ip1)-p(1,2,im1))-
     -       h3p12*(p(1,1,i)*biclc+p(1,2,i)*biclv)

corr 17.07.97
c      cc   = cic-h24*(-3.*p(1,2,ip1)-10.*p(1,2,i)+p(1,2,im1))-
      cic  = cic-h24*(-3.*p(1,2,ip1)-10.*p(1,2,i)+p(1,2,im1))-
     -       h3p12*(p(1,1,i)*ciclc+p(1,2,i)*ciclv)
       fi   = fi-h3p12*(p(1,1,i)*ficl+p(1,2,i)*ficlv)

c
      aiv  = aiv-h24*(-p(2,1,ip1)+10.*p(2,1,i)+3.*p(2,1,im1))-
     -       h3p12*(p(2,1,i)*aiclv+p(2,2,i)*aiclc)
      biv  = biv-h6*(p(2,1,ip1)-p(2,1,im1))-
     -       h3p12*(p(2,1,i)*biclv+p(2,2,i)*biclc)
      civ  = civ-h24*(-3.*p(2,1,ip1)-10.*p(2,1,i)+p(2,1,im1))-
c     -       h3p12*(p(2,1,i)*ciclc+p(2,2,i)*ciclc)
     -       h3p12*(p(2,1,i)*ciclv+p(2,2,i)*ciclc)
      aicv = aicv-h24*(-p(2,2,ip1)+10.*p(2,2,i)+3.*p(2,2,im1))-
     -       h3p12*(p(2,1,i)*aiclcv+p(2,2,i)*aicl)
      bicv = bicv-h6*(p(2,2,ip1)-p(2,2,im1))-
     -       h3p12*(p(2,1,i)*biclcv+p(2,2,i)*bicl)
corr 15.07.97
c      cicv = cicv-h24*(-3.*p(2,1,ip1)-10.*p(2,1,i)+p(2,1,im1))-

      cicv = cicv-h24*(-3.*p(2,2,ip1)-10.*p(2,2,i)+p(2,2,im1))-
     -       h3p12*(p(2,1,i)*ciclcv+p(2,2,i)*cicl)


      fiv  = fiv-h3p12*(p(2,1,i)*ficlv+p(2,2,i)*ficl)

c
c for system with first derivatives.  (end corrections 4)
c

c formulas (57)-(61)
      zz   = ai *am(1,1,im1)+aic *am(2,2,im1)+bi
      ff   = ai *am(1,2,im1)+aic *am(2,1,im1)+bic
      zzv  = aiv*am(2,1,im1)+aicv*am(1,2,im1)+biv
      ffv  = aiv*am(2,2,im1)+aicv*am(1,1,im1)+bicv
      fih  = fi -ai *bm(1,im1)-aic *bm(2,im1)
      fihv = fiv-aiv*bm(2,im1)-aicv*bm(1,im1)
c
      znm  =  ffv/zz
      si1  = -znm* ff+ zzv
      si2  = -znm* ci+ cicv
      si3  = -znm*cic+ civ
      si4  = -znm*fih+ fihv
      znmc =  ff/zzv
      si1c = -znmc*ffv +zz
      si2c = -znmc*cicv+ci
      si3c = -znmc*civ +cic
      si4c = -znmc*fihv+fih
c
      bm(1,i)   =  si4c/si1c
      am(1,1,i) = -si2c/si1c
      am(1,2,i) = -si3c/si1c
      bm(2,i)   =  si4/si1
      am(2,1,i) = -si3/si1
      am(2,2,i) = -si2/si1
c

  10  continue
c

c---------------------------------------- the right system
c

c--------------------------------- i=n

      an   =  25.*d2(1)+h12*f2(1)
      bn   = -48.*d2(1)
      cn   =  36.*d2(1)
      dn   = -16.*d2(1)
      en   =  3.*d2(1)
      ukn  =  g2(1)*h12
c
      anv  =  25.*d2(2)+h12*f2(2)
      bnv  = -48.*d2(2)
      cnv  =  36.*d2(2)
      dnv  = -16.*d2(2)
      env  =  3.*d2(2)
      uknv =  g2(2)*h12

c
c--------------------------------- i=n-1
c
corr for general case
	  i  = n1
	im1  = i-1
	ip1  = i+1

c formulas (26)
      an1  =  1.
      bn1  = -2.+h7d6*f(1,1,n1)
      cn1  =  1.-h5d12*f(1,1,n2)
      dn1  =  hd3*f(1,1,n3)
      en1  = -hd12*f(1,1,n4)
      bnc1 =  h7d6*f(1,2,n1)
      cnc1 = -h5d12*f(1,2,n2)
      dnc1 =  hd3*f(1,2,n3)
      enc1 = -hd12*f(1,2,n4)
      uknh1=  uk(1,n1)*h7d6-h5d12*uk(1,n2)+hd3*uk(1,n3)-hd12*uk(1,n4)
c


      anv1 =  1.
      bnv1 = -2.+h7d6*f(2,1,n1)
      cnv1 =  1.-h5d12*f(2,1,n2)
      dnv1 =  hd3*f(2,1,n3)
      env1 = -hd12*f(2,1,n4)
      bncv1=  h7d6*f(2,2,n1)
      cncv1= -h5d12*f(2,2,n2)
      dncv1=  hd3*f(2,2,n3)
      encv1= -hd12*f(2,2,n4)
      uknhv1 = uk(2,n1)*h7d6-h5d12*uk(2,n2)+hd3*uk(2,n3)-hd12*uk(2,n4)


corr for general case
	anc1  = 0.
	ancv1 = 0.

c
c for system with first derivatives.  (begin corrections 5, formulas 20,26)
c


	r    =  0.5*p(1,1,n3)/h
	s    = -f(1,1,n3)-2.*p(1,1,n2)/h
	u    = -0.5*p(1,1,n3)/h+4.*f(1,1,n2)+1.5*p(1,1,n1)/h
	v    =  2.*p(1,1,n2)/h-3.*f(1,1,n1)
	w    = -1.5*p(1,1,n1)/h

c	rc   =  0.5*p(1,2,n3)
	rc   =  0.5*p(1,2,n3)/h
	sc   = -f(1,2,n3)-2.*p(1,2,n2)/h
	uc   = -0.5*p(1,2,n3)/h+4.*f(1,2,n2)+1.5*p(1,2,n1)/h
	vc   =  2.*p(1,2,n2)/h-3.*f(1,2,n1)
	wc   = -1.5*p(1,2,n1)/h
	t    =  uk(1,n3)-4.*uk(1,n2)+3.*uk(1,n1)

c	rv   =  0.5*p(2,1,n3)
	rv   =  0.5*p(2,1,n3)/h
	sv   = -f(2,1,n3)-2.*p(2,1,n2)/h
	uv   = -0.5*p(2,1,n3)/h+4.*f(2,1,n2)+1.5*p(2,1,n1)/h
	vv   =  2.*p(2,1,n2)/h-3.*f(2,1,n1)
	wv   = -1.5*p(2,1,n1)/h

c	rcv  =  0.5*p(2,2,n3)
	rcv  =  0.5*p(2,2,n3)/h
	scv  = -f(2,2,n3)-2.*p(2,2,n2)/h
	ucv  = -0.5*p(2,2,n3)/h+4.*f(2,2,n2)+1.5*p(2,2,n1)/h
	vcv  =  2.*p(2,2,n2)/h-3.*f(2,2,n1)
	wcv  = -1.5*p(2,2,n1)/h
	tv   =  uk(2,n3)-4.*uk(2,n2)+3.*uk(2,n1)


	an1   = an1+h712*p(1,1,n1)-h3p12*(p(1,1,n1)*w+p(1,2,n1)*wcv)
	bn1   = bn1-h524*p(1,1,n2)-h3p12*(p(1,1,n1)*v+p(1,2,n1)*vcv)
	cn1   = cn1-h24*(-p(1,1,n4)-4.*p(1,1,n3)+14.*p(1,1,n1))-
     -          h3p12*(p(1,1,n1)*u+p(1,2,n1)*ucv)
	dn1   = dn1-h24*(4.*p(1,1,n4)-5.*p(1,1,n2))-
     -          h3p12*(p(1,1,n1)*s+p(1,2,n1)*scv)
	en1   = en1+h8*p(1,1,n4)-
     -          h3p12*(p(1,1,n1)*r+p(1,2,n1)*rcv)
	anc1  = anc1+h712*p(1,2,n1)-
     -          h3p12*(p(1,1,n1)*wc+p(1,2,n1)*wv)
	bnc1  = bnc1-h524*p(1,2,n2)-
     -          h3p12*(p(1,1,n1)*vc+p(1,2,n1)*vv)
	cnc1  = cnc1-h24*(-p(1,2,n4)-4.*p(1,2,n3)+14.*p(1,2,n1))-
     -          h3p12*(p(1,1,n1)*uc+p(1,2,n1)*uv)
	dnc1  = dnc1-h24*(4.*p(1,2,n1)-5.*p(1,2,n2))-
     -          h3p12*(p(1,1,n1)*sc+p(1,2,n1)*sv)
	enc1  = enc1+h8*p(1,2,n4)-
     -          h3p12*(p(1,1,n1)*rc+p(1,2,n1)*rv)


      uknh1   = uknh1+h3p12*(p(1,1,n1)*t+p(1,2,n1)*tv)


c
	anv1  = anv1+h712*p(2,1,n1)-h3p12*(p(2,1,n1)*wv+p(2,2,n1)*wc)
	bnv1  = bnv1-h524*p(2,1,n2)-h3p12*(p(2,1,n1)*vv+p(2,2,n1)*vc)
	cnv1  = cnv1-h24*(-p(2,1,n4)-4.*p(2,1,n3)+14.*p(2,1,n1))-
     -          h3p12*(p(2,1,n1)*uv+p(2,2,n1)*uc)
	dnv1  = dnv1-h24*(4.*p(2,1,n4)-5.*p(2,1,n1))-
     -          h3p12*(p(2,1,n1)*sv+p(2,2,n1)*sc)
	env1  = env1+h8*p(2,1,n4)-
     -          h3p12*(p(2,1,n1)*rv+p(2,2,n1)*rc)
	ancv1 = ancv1+h712*p(2,2,n1)-
     -          h3p12*(p(2,1,n1)*wcv+p(2,2,n1)*w)
	bncv1 = bncv1-h524*p(2,2,n2)-
     -          h3p12*(p(2,1,n1)*vcv+p(2,2,n1)*v)
	cncv1 = cncv1-h24*(-p(2,2,n4)-4.*p(2,2,n3)+14.*p(2,2,n1))-
     -          h3p12*(p(2,1,n1)*ucv+p(2,2,n1)*u)
	dncv1 = dncv1-h24*(4.*p(2,2,n1)-5.*p(2,2,n2))-
     -          h3p12*(p(2,1,n1)*scv+p(2,2,n1)*s)
	encv1 = encv1+h8*p(2,2,n4)-
     -          h3p12*(p(2,1,n1)*rcv+p(2,2,n1)*r)


      uknhv1  = uknhv1+h3p12*(p(2,1,n1)*tv+p(2,2,n1)*t)

c
c for system with first derivatives.  (end corrections 5)
c
c
      do 33 i= 1,10
      do 33 j= 1,11
   33 e(i,j) = 0.
c
      e(1,1) = an
      e(1,2) = bn
      e(1,3) = cn
      e(1,4) = dn
      e(1,5) = en
      e(1,11)= ukn
c
      e(2,6) = anv
      e(2,7) = bnv
      e(2,8) = cnv
      e(2,9) = dnv
      e(2,10)= env
      e(2,11)= uknv
c
      e(3,1) = an1
      e(3,2) = bn1
      e(3,3) = cn1
      e(3,4) = dn1
      e(3,5) = en1
      e(3,7) = bnc1
      e(3,8) = cnc1
      e(3,9) = dnc1
      e(3,10)= enc1
      e(3,11)= uknh1
c
      e(4,2) = bncv1
      e(4,3) = cncv1
      e(4,4) = dncv1
      e(4,5) = encv1
      e(4,6) = anv1
      e(4,7) = bnv1
      e(4,8) = cnv1
      e(4,9) = dnv1
      e(4,10)= env1
      e(4,11)= uknhv1

c
c for system with first derivatives.  (begin corrections 6)
c

      e(3,6) = anc1
      e(4,1) = ancv1


c
c for system with first derivatives.  (end corrections 6)
c
c
      e(5,2)   = am(1,1,n2)
      e(5,3)   = -1.
      e(5,7)   = am(1,2,n2)
      e(5,11)  = -bm(1,n2)
c
      e(6,2)   = am(2,2,n2)
      e(6,7)   = am(2,1,n2)
      e(6,8)   = -1.
      e(6,11)  = -bm(2,n2)
c
      e(7,3)   =  am(1,1,n3)
      e(7,4)   = -1.
      e(7,8)   =  am(1,2,n3)
      e(7,11)  = -bm(1,n3)
c
      e(8,3)   =  am(2,2,n3)
      e(8,8)   =  am(2,1,n3)
      e(8,9)   = -1.
      e(8,11)  = -bm(2,n3)
c
      e(9,4)   =  am(1,1,n4)
      e(9,5)   = -1.
      e(9,9)   =  am(1,2,n4)
      e(9,11)  = -bm(1,n4)
c
      e(10,4)  =  am(2,2,n4)
      e(10,9)  =  am(2,1,n4)
      e(10,10) = -1.
      e(10,11) = -bm(2,n4)

      call matin2(e,10,10,mdim,1,index,nerror,determ)
ccc
      y(1,n) = e(1,11)
      y(1,n1)= e(2,11)
      y(1,n2)= e(3,11)
      y(1,n3)= e(4,11)
      y(1,n4)= e(5,11)
      y(2,n) = e(6,11)
      y(2,n1)= e(7,11)
      y(2,n2)= e(8,11)
      y(2,n3)= e(9,11)
      y(2,n4)= e(10,11)
c
c------------------------------------ the reverse 'progonka'
c
  18  continue
      do 3 i = n5,4,-1
      ip1    = i+1
      y(1,i) = bm(1,i)+am(1,1,i)*y(1,ip1)+am(1,2,i)*y(2,ip1)
      y(2,i) = bm(2,i)+am(2,1,i)*y(2,ip1)+am(2,2,i)*y(1,ip1)
  3   continue
c
      y(1,3) = (q5v-v4cv*y(1,4)-v5cv*y(1,5)-v4v*y(2,4)-v5v*y(2,5))/v3cv
      y(2,3) = (q5 -v4  *y(1,4)-v5  *y(1,5)-v4c*y(2,4)-v5c*y(2,5))/v3c
      y(1,2) = q3v-y(1,3)*z3cv-y(1,4)*z4cv-y(1,5)*z5cv-
     -         y(2,3)*z3v -y(2,4)*z4v -y(2,5)*z5v
      y(2,2) = q3 -y(1,3)*z3  -y(1,4)*z4  -y(1,5)*z5-
     -         y(2,3)*z3c -y(2,4)*z4c -y(2,5)*z5c
      y(1,1) = (uk1h -b1*y(1,2) -c1 *y(1,3)-dd1 *y(1,4)-e1 *y(1,5))/a1
      y(2,1) = (uk1hv-b1v*y(2,2)-c1v*y(2,3)-dd1v*y(2,4)-e1v*y(2,5))/a1v
c
      return
      end
c*
c *****************************************************************************
c*
c***********************************************************************
c*
      SUBROUTINE  MATIN2 (A,IDIM1,N1,IDIM2,N2,INDEX,NERROR,DETERM)
c     implicit real*8 (a-h,o-z)
C	 MATRIX INVERSION WITH ACCOMPANYING SOLUTION OF LINEAR EQUATIONS
      DOUBLE PRECISION A,DETERM,DETER,PIVOT,SWAP
      DIMENSION A(IDIM1),INDEX(IDIM1)
      DETER=1.0D0
      N=N1
      IEMAT=N+N2
      IDIM=IDIM1
      NMIN1=N-1
C	 THE ROUTINE DOES ITS OWN EVALUATION FOR DOUBLE SUBSCRIPTING OF
C	 ARRAY A.
      IPIVC=1-IDIM
C	 MAIN LOOP TO INVERT THE MATRIX
      DO 11 MAIN=1,N
      PIVOT=0.0D0
      IPIVC=IPIVC+IDIM
C	 SEARCH FOR NEXT PIVOT IN COLUMN MAIN.
      IPIVC1=IPIVC+MAIN-1
      IPIVC2=IPIVC +NMIN1
      DO 2 I1=IPIVC1,IPIVC2
      IF(DABS(A(I1))-DABS(PIVOT)) 2,2,1
    1 PIVOT=A(I1)
      LPIV=I1
    2 CONTINUE
C	 IS PIVOT DIFFERENT FROM ZERO
      IF(PIVOT) 3,15,3
C	 GET THE PIVOT-LINE INDICATOR AND SWAP LINES IF NECESSARY
    3 ICOL=LPIV-IPIVC+1
      INDEX(MAIN)=ICOL
      IF(ICOL-MAIN) 6,6,4
C	 COMPLEMENT THE DETERMINANT
    4 DETER=-DETER
C	 POINTER TO LINE PIVOT FOUND
      ICOL=ICOL-IDIM
C	 POINTER TO EXACT PIVOT LINE
      I3=MAIN-IDIM
      DO 5 I=1,IEMAT
      ICOL=ICOL+IDIM
      I3=I3+IDIM
      SWAP=A(I3)
      A(I3)=A(ICOL)
    5 A(ICOL)=SWAP
C	 COMPUTE DETERMINANT
    6 DETER=DETER*PIVOT
      PIVOT=1./PIVOT
C	 TRANSFORM PIVOT COLUMN
      I3=IPIVC+NMIN1
      DO 7 I=IPIVC,I3
    7 A(I)=-A(I)*PIVOT
      A(IPIVC1)=PIVOT
C	 PIVOT ELEMENT TRANSFORMED
C
C	 NOW CONVERT REST OF THE MATRIX
      I1=MAIN-IDIM
C	 POINTER TO PIVOT LINE ELEMENTS
      ICOL=1-IDIM
C	 GENERAL COLUMN POINTER
      DO 10 I=1,IEMAT
      ICOL=ICOL+IDIM
      I1=I1+IDIM
C	 POINTERS MOVED
      IF(I-MAIN) 8,10,8
C	 PIVOT COLUMN EXCLUDED
    8 JCOL=ICOL+NMIN1
      SWAP=A(I1)
      I3=IPIVC-1
      DO 9 I2=ICOL,JCOL
      I3=I3+1
    9 A(I2)=A(I2)+SWAP*A(I3)
      A(I1)=SWAP*PIVOT
   10 CONTINUE
   11 CONTINUE
C	 NOW REARRANGE THE MATRIX TO GET RIGHT INVERS
      DO 14 I1=1,N
      MAIN=N+1-I1
      LPIV=INDEX(MAIN)
      IF(LPIV-MAIN) 12,14,12
   12 ICOL=(LPIV-1)*IDIM+1
      JCOL=ICOL+NMIN1
      IPIVC=(MAIN-1)*IDIM+1-ICOL
      DO 13 I2=ICOL,JCOL
      I3=I2+IPIVC
      SWAP=A(I2)
      A(I2)=A(I3)
   13 A(I3)=SWAP
   14 CONTINUE
      DETERM=DETER
      NERROR=0
      RETURN
   15 NERROR=MAIN
      DETERM=DETER
      RETURN
      END
